/*************************************************************
* main.c - openwii umod2, elegantly simple version
* Copyright YOLD 3173 OpenWii all rights reversed.
**************************************************************/

#include "common.h"


/*teh main!*/
int main()
{
	uint8_t region;
	uint16_t ret_word;	
	machInit();
	LEDON;		//turn led on
	Sync();
	sendBlock(0x408000,(uint8_t *)&BINARYSTART,(uint16_t)&BINARYSIZE);
	//region=USA_R;
	region=eeprom_read_byte(EEREGADDR);
	if((region==EEERASEDSTATE) || SW0IN ) { //or if a switch is pressed at bootup?
		region=0xff;
	} else {
		LEDOFF;
	}
	SerialRequest(CMD_WRITE, REGXFERADDR,0x1,region,NULL);
	while(1) {
//		serialWriteByte(UNLOCKADDR,0x41);
//		serialWriteByte(((uint16_t)&_unlockAddr),0x41);
		SerialRequest(CMD_WRITE, UNLOCKADDR, 1, 0x41, NULL);
		if(SerialRequest(CMD_READ, STACKRET, 2, 0x0, &ret_word)==0) {
			if(ret_word == ORGRET) {
//				serialWriteWord(STACKRET,0x8000);
				SerialRequest(CMD_WRITE, STACKRET, 2, 0x8000, NULL);
//				serialWriteByte(STACKRET+2,0x40);
				SerialRequest(CMD_WRITE, STACKRET+2, 1, 0x40, NULL);
				LEDON;
			}
		} else {
			Resync();
		}
		if(region==0xff) {
		        SerialRequest(CMD_READ, REGXFERADDR, 1, 0x0, &ret_word);
		        if((uint8_t)ret_word != region) {
		                region=(uint8_t)ret_word;
		                eeprom_write_byte(EEREGADDR,region);
		                LEDOFF;
		        }
		}
	}	
}
