/*************************************************************
* serial.h - openwii serial header
**************************************************************/
#ifndef SERIAL_H_
#define SERIAL_H_

#define CMD_READ 0xFF
#define CMD_WRITE 0xFE

/*For drive ID 0x40bca7*/
#define D2ACHK 0x2605 /*d2a/dms drive id*/
#define D2BCHK 0x0709 /*d2b drive id*/
#define SERIAL_CMD_SIZE 10

uint8_t Sync();
void Resync();
uint8_t SerialRequest(uint8_t command, uint32_t offset, uint8_t size, uint16_t data, uint16_t *ret);
void serialWriteByte(uint32_t offset, uint8_t data);
void serialWriteWord(uint32_t offset, uint16_t data);
void sendBlock(uint32_t offset, uint8_t *buff, uint16_t size);
#endif /*SERIAL_H_*/
